Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py	(revision 15841)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/applicants/browser.py	(revision 15842)
@@ -65,5 +65,6 @@
     @property
     def target_url(self):
-        if not self.context.r_company:
+        if not self.context.p_state in ('waived', 'scholarship') \
+            and not self.context.r_company:
             return ''
         return self.view.url(self.view.context, self.target)
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser.py	(revision 15841)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/interswitch/browser.py	(revision 15842)
@@ -92,5 +92,5 @@
             self.context.student.current_session, self.context):
             return ''
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             return ''
         return self.view.url(self.view.context, self.target)
@@ -106,5 +106,5 @@
             self.context.__parent__.__parent__.year, self.context):
             return ''
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             return ''
         return self.view.url(self.view.context, self.target)
@@ -163,5 +163,5 @@
             self.context.student.current_session, self.context):
             return
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             self.flash(_('This ticket has already been paid.'), type='danger')
             return
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py	(revision 15841)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/applicantsbrowser.py	(revision 15842)
@@ -72,5 +72,5 @@
             self.context.__parent__.__parent__.year, self.context):
             return ''
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             return ''
         return self.view.url(self.view.context, self.target)
@@ -113,5 +113,5 @@
             self.context.__parent__.__parent__.year, self.context):
             return
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             self.flash(_('This ticket has already been paid.'), type='danger')
             return
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py	(revision 15841)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/studentsbrowser.py	(revision 15842)
@@ -81,5 +81,5 @@
             self.context.student.current_session, self.context):
             return ''
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             return ''
         return self.view.url(self.view.context, self.target)
@@ -123,5 +123,5 @@
             self.context.student.current_session, self.context):
             return
-        if self.context.p_state in ('paid', 'waived'):
+        if self.context.p_state in ('paid', 'waived', 'scholarship'):
             self.flash(_('This ticket has already been paid.'), type='danger')
             return
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py	(revision 15841)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/remita/webservices.py	(revision 15842)
@@ -96,5 +96,5 @@
                 continue
             ticket = results[0]
-            if ticket.p_state == 'waived':
+            if ticket.p_state in ('waived', 'scholarship'):
                 failed += 1
                 continue
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py	(revision 15841)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/browser.py	(revision 15842)
@@ -392,5 +392,6 @@
         tabledata.append(sorted(
             [value for value in self.context['payments'].values()
-             if value.p_state in ('paid', 'waived')], key=lambda value: value.p_session))
+             if value.p_state in ('paid', 'waived', 'scholarship')],
+             key=lambda value: value.p_session))
         tableheader.append([(P_ID,'p_id', 4.2),
                          #(CD,'creation_date', 3),
Index: main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/viewlets.py
===================================================================
--- main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/viewlets.py	(revision 15841)
+++ main/kofacustom.nigeria/trunk/src/kofacustom/nigeria/students/viewlets.py	(revision 15842)
@@ -60,5 +60,6 @@
     @property
     def target_url(self):
-        if not self.context.r_company:
+        if not self.context.p_state in ('waived', 'scholarship') \
+            and not self.context.r_company:
             return ''
         return self.view.url(self.view.context, self.target)