Index: main/kofacustom.skeleton/trunk/etc/site.zcml.in
===================================================================
--- main/kofacustom.skeleton/trunk/etc/site.zcml.in	(revision 15756)
+++ main/kofacustom.skeleton/trunk/etc/site.zcml.in	(revision 15847)
@@ -46,15 +46,4 @@
                  />
 
-      <!-- XMLRPC user for demo and testing
-           Plaintext password is xmlrpcuser1 -->
-      <principal id="zope.xmlrpcuser1"
-                 title="XMLRPC User 1"
-                 login="xmlrpcuser1"
-                 password="{SSHA}ZaL4-UiwmSu6AbLYY-yCS_8vtKpH5Hc6"
-                 password_manager="SSHA"
-                 />
-      <grant role="waeup.xmlrpcusers1"
-             principal="zope.xmlrpcuser1" />
-
       <!-- Replace the following directive if you do not want
            public access -->
Index: main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/etranzact/browser.py
===================================================================
--- main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/etranzact/browser.py	(revision 15756)
+++ main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/etranzact/browser.py	(revision 15847)
@@ -22,8 +22,10 @@
 from kofacustom.nigeria.etranzact.studentsbrowser import (
     EtranzactPageStudent, EtranzactReceiveResponseStudent,
-    EtranzactRequestPaymentStatusPageStudent)
+    EtranzactRequestPaymentStatusPageStudent,
+    webconnect_module_activated)
 from kofacustom.nigeria.etranzact.payoutletbrowser import (
     EtranzactEnterPinPageStudent, EtranzactEnterPinPageApplicant,
-    EtranzactQueryHistoryPageStudent, EtranzactQueryHistoryPageApplicant)
+    EtranzactQueryHistoryPageStudent, EtranzactQueryHistoryPageApplicant,
+    payoutlet_module_activated)
 from kofacustom.nigeria.etranzact.payoutletwebservice  import NigeriaPaymentDataWebservice
 
@@ -52,4 +54,7 @@
         # Already now it becomes an Etranzact payment. We set the net amount
         # and add the gateway amount.
+        if not webconnect_module_activated(
+            self.context.__parent__.__parent__.year, self.context):
+            return _("Etranzact payments deactivated.")
         if not self.context.r_company:
             self.context.net_amt = self.context.amount_auth
@@ -91,4 +96,7 @@
         # Already now it becomes an Etranzact payment. We set the net amount
         # and add the gateway amount.
+        if not webconnect_module_activated(
+            self.context.student.current_session, self.context):
+            return _("Etranzact payments deactivated.")
         if not self.context.r_company:
             self.context.net_amt = self.context.amount_auth
Index: main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/interfaces.py
===================================================================
--- main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/interfaces.py	(revision 15756)
+++ main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/interfaces.py	(revision 15847)
@@ -67,4 +67,19 @@
         )
 
+    interswitch_enabled = schema.Bool(
+        title = _(u'Interswitch integration enabled'),
+        default = False,
+        )
+
+    etranzact_webconnect_enabled = schema.Bool(
+        title = _(u'Etranzact Webconnect integration enabled'),
+        default = False,
+        )
+
+    etranzact_payoutlet_enabled = schema.Bool(
+        title = _(u'Etranzact Payoutlet integration enabled'),
+        default = False,
+        )
+
 
     # Additional fees in custom package add here
Index: main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/remita/browser.py
===================================================================
--- main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/remita/browser.py	(revision 15756)
+++ main/kofacustom.skeleton/trunk/src/kofacustom/skeleton/remita/browser.py	(revision 15847)
@@ -88,5 +88,6 @@
 
     def update(self):
-        if not module_activated(self.context.student.current_session):
+        if not module_activated(
+            self.context.student.current_session, self.context):
             return
         self.orderId = self.context.p_id
@@ -154,5 +155,6 @@
 
     def update(self):
-        if not module_activated(self.context.__parent__.__parent__.year):
+        if not module_activated(
+            self.context.__parent__.__parent__.year, self.context):
             return
         self.orderId = self.context.p_id