Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/interfaces.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/interfaces.py	(revision 15857)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/interfaces.py	(revision 15858)
@@ -62,4 +62,10 @@
     )
 
+subtype_vocab = SimpleKofaVocabulary(
+    (_('UTME'), 'utme'),
+    (_('Direct Entry'), 'de'),
+    (_('Inter Uni Transfer'), 'transfer'),
+    )
+
 class ICustomUGApplicant(IApplicantBaseData):
     """An undergraduate applicant.
@@ -70,4 +76,9 @@
     """
 
+    subtype = schema.Choice(
+        title = _(u'Application Subtype'),
+        vocabulary = subtype_vocab,
+        required = False,
+        )
     disabilities = schema.Choice(
         title = _(u'Disability'),
@@ -172,4 +183,40 @@
         defaultFactory=list,
         )
+    hq_type = schema.Choice(
+        title = _(u'Qualification Obtained'),
+        required = False,
+        readonly = False,
+        vocabulary = high_qual,
+        )
+    hq_matric_no = schema.TextLine(
+        title = _(u'Former Matric Number'),
+        required = False,
+        readonly = False,
+        )
+    hq_degree = schema.Choice(
+        title = _(u'Class of Degree'),
+        required = False,
+        readonly = False,
+        vocabulary = high_grade,
+        )
+    hq_school = schema.TextLine(
+        title = _(u'Institution Attended'),
+        required = False,
+        readonly = False,
+        )
+    hq_session = schema.TextLine(
+        title = _(u'Years Attended'),
+        required = False,
+        readonly = False,
+        )
+    hq_disc = schema.TextLine(
+        title = _(u'Discipline'),
+        required = False,
+        readonly = False,
+        )
+    jamb_subjects = schema.Text(
+        title = _(u'Subjects and Scores'),
+        required = False,
+        )
     jamb_subjects = schema.Text(
         title = _(u'Subjects and Scores'),
@@ -240,4 +287,6 @@
         )
 
+ICustomUGApplicant[
+    'subtype'].order =  ICustomUGApplicant['lga'].order
 ICustomUGApplicant[
     'locked'].order =  ICustomUGApplicant['suspended'].order
@@ -293,5 +342,5 @@
         """
 
-class ICustomUGApplicantEdit(INigeriaUGApplicantEdit):
+class ICustomUGApplicantEdit(ICustomUGApplicant):
     """An undergraduate applicant interface for edit forms.
 
@@ -305,5 +354,5 @@
     """
 
-class ICustomPGApplicantEdit(INigeriaPGApplicantEdit):
+class ICustomPGApplicantEdit(ICustomPGApplicant):
     """A postgraduate applicant interface for editing.
 
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/utils.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/utils.py	(revision 15857)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/utils.py	(revision 15858)
@@ -44,3 +44,21 @@
         'ase': ['Admission Screening Exercise', 'ASE'], # successor of putme
         'pg': ['Postgraduate Programmes', 'PG'],
+        'ug': ['Undergraduate Programmes', 'UG'],
         }
+
+    SEPARATORS_DICT = {
+        'form.applicant_id': _(u'Base Data'),
+        'form.course1': _(u'Programmes/Courses Desired'),
+        'form.hq_type': _(u'Higher Education Record (where applicable)'),
+        'form.presently': _(u'Course or Programme Presently Attending'),
+        'form.nysc_year': _(u'NYSC Information'),
+        'form.employer': _(u'Employment History'),
+        'form.jamb_subjects': _(u'JAMB Data'),
+        'form.jamb_subjects_list': _(u'JAMB Data'),
+        'form.notice': _(u'Application Process Information'),
+        'form.pp_school': _(u'Post Primary School Qualification'),
+        'form.presently_inst': _(u'Presently attending a course or programme'),
+        'form.fst_sit_fname': _(u'First Sitting Record'),
+        'form.scd_sit_fname': _(u'Second Sitting Record'),
+        'form.referees': _(u'Referees'),
+        }
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py	(revision 15857)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py	(revision 15858)
@@ -147,6 +147,7 @@
         'basic': 'UAS, PUTME, PUDE, PCE, PRENCE',
         'no': 'No Application',
-        'pg': 'Postgraduate',
+        'pg': 'Postgraduate Programmes',
         'pre': 'Pre-Degree Studies',
         'pt': 'Part-Time Degree Programmes',
+        'ut': 'Undergraduate Programmes',
         }