Index: main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py	(revision 15866)
+++ main/waeup.aaue/trunk/src/waeup/aaue/applicants/tests/test_browser.py	(revision 15867)
@@ -288,5 +288,4 @@
         self.browser.getControl(name="form.email").value = 'xx@yy.zz'
         self.browser.getControl(name="form.nationality").value = ['NG']
-        #self.browser.getControl(name="form.sex").value = ['f']
         self.browser.getControl(name="form.firstname").value = 'Angela'
         self.browser.getControl(name="form.lastname").value = 'Merkel'
@@ -306,6 +305,6 @@
         self.browser.getControl("Add online payment ticket").click()
         self.assertTrue('Payment ticket created' in self.browser.contents)
-        self.assertTrue('<span>100.0</span>' in self.browser.contents)
-        self.assertEqual(applicant.values()[0].amount_auth, 100.0)
+        self.assertTrue('<span>200.0</span>' in self.browser.contents)
+        self.assertEqual(applicant.values()[0].amount_auth, 200.0)
         return
 
Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 15866)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 15867)
@@ -42,5 +42,5 @@
 INSTITUTION_NAME = 'AAU Ekpoma'
 CURRENCY = '566'
-GATEWAY_AMT = 250.0
+GATEWAY_AMT = 200.0
 POST_ACTION = 'https://webpay.interswitchng.com/paydirect/pay'
 
Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 15866)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/tests.py	(revision 15867)
@@ -88,5 +88,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Application Fee" item_amt="775000" bank_id="117" acct_num="1010835352"'
+            'item_name="Application Fee" item_amt="780000" bank_id="117" acct_num="1010835352"'
             in self.browser.contents)
         self.assertTrue(
@@ -119,5 +119,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Application Fee" item_amt="575000" bank_id="117" acct_num="1010835352"'
+            'item_name="Application Fee" item_amt="580000" bank_id="117" acct_num="1010835352"'
             in self.browser.contents)
         self.assertTrue(
@@ -153,5 +153,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Application Fee" item_amt="775000" bank_id="117" acct_num="1010835352"'
+            'item_name="Application Fee" item_amt="780000" bank_id="117" acct_num="1010835352"'
             in self.browser.contents)
         self.assertTrue(
@@ -184,5 +184,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Application Fee" item_amt="775000" bank_id="7" acct_num="1014847058"'
+            'item_name="Application Fee" item_amt="780000" bank_id="7" acct_num="1014847058"'
             in self.browser.contents)
 
@@ -208,5 +208,5 @@
         self.certificate.study_mode = 'ug_pt'
         self.student['studycourse'].entry_session = 2013
-        self.student['studycourse'].certificate.school_fee_1 = 50250.0
+        self.student['studycourse'].certificate.school_fee_1 = 50200.0
         self.app['configuration']['2004'].union_fee = 1000.0
         self.app['configuration']['2004'].welfare_fee = 500.0
@@ -224,6 +224,6 @@
         self.browser.getLink(self.value).click()
         self.assertTrue('Amount Authorized' in self.browser.contents)
-        # 50250 + 1000 + 500 -500
-        self.assertTrue('<span>51250.0</span>' in self.browser.contents)
+        # 50200 + 1000 + 500 - 400
+        self.assertTrue('<span>51300.0</span>' in self.browser.contents)
         self.payment_url = self.browser.url
         self.browser.getLink("Pay via Interswitch", index=0).click()
@@ -240,5 +240,5 @@
         self.assertEqual(self.student.current_mode, 'ug_pt')
         self.assertTrue(
-            '<input type="hidden" name="amount" value="5125000" />'
+            '<input type="hidden" name="amount" value="5130000" />'
             in self.browser.contents)
         self.assertTrue(
@@ -285,10 +285,10 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="School Fee Plus" item_amt="4750000" bank_id="117" '
+            'item_name="School Fee Plus" item_amt="4755000" bank_id="117" '
             'acct_num="1010827641"' in self.browser.contents)
 
     def test_interswitch_form_pt_acceptance_fees(self):
         self.certificate.study_mode = 'ug_pt'
-        self.app['configuration']['2004'].clearance_fee_ug_pt = 40250.0
+        self.app['configuration']['2004'].clearance_fee_ug_pt = 40200.0
         self.app['configuration']['2004'].matric_gown_fee = 2000.0
         self.app['configuration']['2004'].lapel_fee = 800.0
@@ -306,6 +306,6 @@
         self.browser.getLink(self.value).click()
         self.assertTrue('Amount Authorized' in self.browser.contents)
-        # 40250 + 2000 + 800 - 500
-        self.assertTrue('<span>42550.0</span>' in self.browser.contents)
+        # 40200 + 2000 + 800 - 400
+        self.assertTrue('<span>42600.0</span>' in self.browser.contents)
         self.payment_url = self.browser.url
         self.browser.getLink("Pay via Interswitch", index=0).click()
@@ -314,5 +314,5 @@
         self.assertTrue('Total Amount Authorized:' in self.browser.contents)
         self.assertTrue(
-            '<input type="hidden" name="amount" value="4255000" />'
+            '<input type="hidden" name="amount" value="4260000" />'
             in self.browser.contents)
         self.assertTrue(
@@ -347,5 +347,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Acceptance Fee Plus" item_amt="4130000" bank_id="117" '
+            'item_name="Acceptance Fee Plus" item_amt="4135000" bank_id="117" '
             'acct_num="1010827641"' in self.browser.contents)
 
@@ -378,5 +378,5 @@
             in self.browser.contents)
         self.assertTrue(
-            'item_name="Concessional Fee" item_amt="131700" '
+            'item_name="Concessional Fee" item_amt="136700" '
             'bank_id="117" acct_num="1010827641"'
             in self.browser.contents)
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 15866)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 15867)
@@ -274,8 +274,8 @@
         self.assertEqual(self.student['payments'].values()[0].p_category, 'schoolfee_1')
         self.assertEqual(self.student['payments'].values()[1].p_category, 'schoolfee_2')
-        # (6666-250)/2 + 1250 + 750 - 500 + 250
-        self.assertEqual(self.student['payments'].values()[0].amount_auth, 4958.0)
-        # (6666-250)/2 + 250
-        self.assertEqual(self.student['payments'].values()[1].amount_auth, 3458.0)
+        # (6666-200)/2 + 1250 + 750 - 400 + 200
+        self.assertEqual(self.student['payments'].values()[0].amount_auth, 5033.0)
+        # (6666-200)/2 + 200
+        self.assertEqual(self.student['payments'].values()[1].amount_auth, 3433.0)
         # The  two payments belong to the same session and level.
         self.assertEqual(self.student['payments'].values()[0].p_session, 2015)
@@ -309,8 +309,8 @@
         self.browser.getControl("Create ticket").click()
         self.assertTrue('ticket created' in self.browser.contents)
-        # (5666-250)/2 + 1250 + 750 - 500 + 250
-        self.assertEqual(self.student['payments'].values()[2].amount_auth, 4458.0)
-        # (5666-250)/2 + 250
-        self.assertEqual(self.student['payments'].values()[3].amount_auth, 2958.0)
+        # (5666-200)/2 + 1250 + 750 - 400 + 200
+        self.assertEqual(self.student['payments'].values()[2].amount_auth, 4533.0)
+        # (5666-200)/2 + 200
+        self.assertEqual(self.student['payments'].values()[3].amount_auth, 2933.0)
         # The last two payments belong to the same session and level.
         self.assertEqual(self.student['payments'].values()[2].p_session, 2016)
@@ -613,8 +613,8 @@
         self.student['studycourse'].current_session = 2016
         self.student['studycourse'].entry_mode = 'ug_ft'
-        self.student['studycourse'].certificate.school_fee_1 = 50250.0
-        self.app['configuration']['2016'].union_fee = 1250.0
-        self.app['configuration']['2016'].welfare_fee = 750.0
-        self.app['configuration']['2016'].id_card_fee = 350.0
+        self.student['studycourse'].certificate.school_fee_1 = 50200.0
+        self.app['configuration']['2016'].union_fee = 1200.0
+        self.app['configuration']['2016'].welfare_fee = 700.0
+        self.app['configuration']['2016'].id_card_fee = 300.0
         self.student.nationality = u'NG'
         # Login
@@ -633,6 +633,6 @@
         self.browser.getLink(value).click()
         self.assertTrue('Amount Authorized' in self.browser.contents)
-        # 50250 + 1000 + 500 + 100 = 51850
-        self.assertEqual(self.student['payments'][value].amount_auth, 51850.0)
+        # 50200 + 1200 + 700 + 300 - 600 = 51800
+        self.assertEqual(self.student['payments'][value].amount_auth, 51800.0)
         self.student['payments'][value].r_company = u'interswitch'
         self.browser.open(self.browser.url + '/payment_slip.pdf')