Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/browser.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/browser.py	(revision 15882)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/applicants/browser.py	(revision 15883)
@@ -87,13 +87,11 @@
         form_fields = grok.AutoFields(IApplicantsContainer).omit(
             'title', 'description')
-        form_fields[
-            'startdate'].custom_widget = FriendlyDatetimeDisplayWidget('le')
-        form_fields[
-            'enddate'].custom_widget = FriendlyDatetimeDisplayWidget('le')
         if self.request.principal.id == 'zope.anybody':
             form_fields = form_fields.omit(
                 'code', 'prefix', 'year', 'mode', 'hidden',
                 'strict_deadline', 'application_category',
-                'application_slip_notice', 'application_fee', 'with_picture')
+                'application_slip_notice',
+                'application_fee', 'with_picture',
+                'startdate', 'enddate')
         return form_fields
 
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interswitch/tests.py
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interswitch/tests.py	(revision 15882)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interswitch/tests.py	(revision 15883)
@@ -60,6 +60,6 @@
         self.browser.open(self.payments_path + '/addop')
         self.browser.getControl(name="form.p_category").value = ['schoolfee']
-        self.browser.getControl("Create ticket").click()
-        self.assertMatches('...ticket created...',
+        self.browser.getControl("Create payment").click()
+        self.assertMatches('...Payment created...',
                            self.browser.contents)
         ctrl = self.browser.getControl(name='val_id')
@@ -130,5 +130,5 @@
         self.browser.open(self.payments_path + '/addop')
         self.browser.getControl(name="form.p_category").value = ['schoolfee']
-        self.browser.getControl("Create ticket").click()
+        self.browser.getControl("Create payment").click()
         self.assertMatches('...ticket created...',
                            self.browser.contents)
@@ -222,5 +222,5 @@
         self.browser.getControl("Save").click()
         self.browser.getControl("Add online").click()
-        self.assertMatches('...ticket created...',
+        self.assertMatches('...Payment created...',
                            self.browser.contents)
         #ctrl = self.browser.getControl(name='val_id')
Index: main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/locales/en/LC_MESSAGES/waeup.kofa.po
===================================================================
--- main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 15882)
+++ main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/locales/en/LC_MESSAGES/waeup.kofa.po	(revision 15883)
@@ -79,2 +79,38 @@
 msgid "Edit application record"
 msgstr "Continue application"
+
+msgid "Payment ticket created."
+msgstr "Payment created."
+
+msgid "${a}: Online Payment Ticket ${b}"
+msgstr "${a}: Online Payment ${b}"
+
+msgid "Add online payment ticket"
+msgstr "Add online payment"
+
+msgid "Payment Tickets"
+msgstr "Payment"
+
+msgid ""
+"<strong>Notice:</strong> If you need to pay for another service, select the "
+"corresponding special application category above, click 'Save' and then 'Add "
+"online payment ticket' again."
+msgstr ""
+"<strong>Notice:</strong> If you need to pay for another service, select the "
+"corresponding special application category above, click 'Save' and then 'Add "
+"online payment' again."
+
+msgid "Add current session payment ticket"
+msgstr "Add current session payment"
+
+msgid "Add previous session payment ticket"
+msgstr "Add previous session payment"
+
+msgid "Add balance payment ticket"
+msgstr "Add balance payment"
+
+msgid "Ticket Creation Date"
+msgstr "Creation Date"
+
+msgid "Create ticket"
+msgstr "Create payment"