Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser.py	(revision 15839)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/browser.py	(revision 15887)
@@ -17,4 +17,5 @@
 ##
 import grok
+import os
 from zope.i18n import translate
 from zope.component import getUtility
@@ -62,28 +63,25 @@
         return """You should note the following as conditions for admission:
 
-1. At the point of registration, you will be required to present the originals
-   of your certificate(s), Jamb Original Result, a Birth Certificate or a Declaration
-   of Age Certificate and Evidence of Citizenship Certificate.
-
-2. Please note that the name by which you are hereby admitted and by which you
-   will be registered is the one which will appear on any certificate that the
-   Federal College of Education, Okene may issue to you on successful completion
-   of your programme except there was a change of name by sworn affidavit or
-   marriage certificate in addition to newspaper publication.
-
-3. You are hereby informed that all fees must be paid at the beginning of
-   the academic session. The current school fees can be obtained from the
-   College website.
-
-4. You will present at the time of registration the Medical Certificate of
-   Fitness from the Federal College of Education, Okene Medical Centre.
-
-5. Please, note that due to shortage of accommodations, students shall be
-   given accommodations on first come, first serve basis.
+1. At the point of registration, you will be required to present the originals of your certificate(s), 
+   Jamb Original Result, a Birth Certificate or a Declaration of Age Certificate and Evidence of
+   Citizenship Certificate.
+
+2. Please note that the name by which you are hereby admitted and by which you will be registered 
+   is the one which will appear on any certificate that the Federal College of Education, Okene may
+   issue to you on successful completion of your programme except there was a change of name by 
+   sworn affidavit or marriage certificate in addition to newspaper publication.
+
+3. You are hereby informed that all fees must be paid at the beginning of the academic session. 
+   The current school fees can be obtained from the College website.
+
+4. You will present at the time of registration the Medical Certificate of Fitness from the Federal
+   College of Education, Okene Medical Centre.
+
+5. Please, note that due to shortage of accommodations, students shall be given accommodations
+   on first come, first serve basis.
 
 6. The offer is not transferable to another session.
 
-7. You will sign a declaration of good conduct except by deferment on your
-   arrival at the College.
+7. You will sign a declaration of good conduct except by deferment on your arrival at the College.
 
 Accept my congratulations.
@@ -96,9 +94,13 @@
 """
 
-
     def render(self):
         students_utils = getUtility(IStudentsUtils)
+        letterhead_path = os.path.join(
+            os.path.dirname(__file__), 'static', 'letterhead_admission.jpg')
+        if self.context.student.current_mode.startswith('ug'):
+            letterhead_path = None
         return students_utils.renderPDFAdmissionLetter(self,
             self.context.student, omit_fields=self.omit_fields,
+            letterhead_path=letterhead_path,
             post_text=self._post_text)
 
Index: main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py
===================================================================
--- main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py	(revision 15839)
+++ main/waeup.fceokene/trunk/src/waeup/fceokene/students/tests/test_browser.py	(revision 15887)
@@ -394,4 +394,10 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         self.assertEqual(self.browser.headers['Content-Type'], 'application/pdf')
+        path = os.path.join(samples_dir(), 'admission_slip_combined.pdf')
+        open(path, 'wb').write(self.browser.contents)
+        print "Sample PDF admission_slip_combined.pdf written to %s" % path
+        self.certificate.study_mode = 'pd_ft'
+        self.browser.open(self.student_path)
+        self.browser.getLink("Download admission letter").click()
         path = os.path.join(samples_dir(), 'admission_slip.pdf')
         open(path, 'wb').write(self.browser.contents)