Index: main/waeup-ansible/README-vhosts.rst
===================================================================
--- main/waeup-ansible/README-vhosts.rst	(revision 15914)
+++ main/waeup-ansible/README-vhosts.rst	(revision 15915)
@@ -79,7 +79,7 @@
 ===========================
 
-In ``hosts`` add the new box in  the ``[yet-untouched]`` section::
+In ``hosts`` add the new box in  the ``[yet_untouched]`` section::
 
-  [yet-untouched]
+  [yet_untouched]
   localhost:3333 ansible_user=ubuntu
 
@@ -89,5 +89,5 @@
 
 This should secure the new box. From now on, we can connect via the regular
-ways. You can quit the open shell now and remove the ``[yet-untouched]`` entry
+ways. You can quit the open shell now and remove the ``[yet_untouched]`` entry
 in ``hosts``.
 
@@ -95,5 +95,5 @@
 
   # hosts
-  [yet-untouched]
+  [yet_untouched]
 
   [bootstrapped]
Index: main/waeup-ansible/README.rst
===================================================================
--- main/waeup-ansible/README.rst	(revision 15914)
+++ main/waeup-ansible/README.rst	(revision 15915)
@@ -46,9 +46,9 @@
    as `root` on each targeted system.
 
-3) For each server to handle, make an entry in the ``[yet-untouched]`` section
+3) For each server to handle, make an entry in the ``[yet_untouched]`` section
    of the ``hosts`` file like this::
 
      # hosts
-     [yet-untouched]
+     [yet_untouched]
      h23.waeup.org ansible_user=root ansible_ssh_pass=so-secret ansible_sudo_pass="{{ ansible_ssh_pass }}"
      h24.waeup.org ansible_user=root ansible_ssh_pass=123456789 ansible_sudo_pass="{{ ansible_ssh_pass }}"
@@ -104,5 +104,5 @@
    to actually perform the changes.
 
-6) In `hosts` move the host we handle from ``[yet-untouched]`` over to
+6) In `hosts` move the host we handle from ``[yet_untouched]`` over to
    ``[bootstapped]``.
 
@@ -252,8 +252,8 @@
 file, normally ``hosts-virtual``, with a line like this:
 
-  [yet-untouched]
+  [yet_untouched]
   vh5.sample.org ansible_host=192.168.36.10 ansible_user=root
 
-in the "yet-untouched" section.
+in the "yet_untouched" section.
 
 Afterwards try:
Index: main/waeup-ansible/bootstrap.yml
===================================================================
--- main/waeup-ansible/bootstrap.yml	(revision 15914)
+++ main/waeup-ansible/bootstrap.yml	(revision 15915)
@@ -9,10 +9,10 @@
 # it! Do not run this playbook without having read the README.
 #
-- hosts: yet-untouched
+- hosts: yet_untouched
   become: yes
   vars:
     # Enable root access via SSH? Set to false not before user
     # accounts are active.
-    permit_ssh_root: true
+    permit_ssh_root: false
     # Allow admin users below to become root w/o entering password?
     permit_become_root_no_password: true
@@ -20,6 +20,6 @@
     #      $ diceware -d '-' -n 6 --no-caps | tee mypw | mkpasswd -s --method=sha-512 >> mypw
     admin_users:
-      ulif:
-        hashed_pw: "$6$iuoXy2wO3elWM6d2$NR/ayKF58q0Bm0BdsR.g.Nt5xYzD0s0t17ZjrYaRpY7nkRekjgHTnqw849pK9FdynmNZAioW6oQBQx3BB5kcd0"
+        uli:
+            hashed_pw: "$6$iuoXy2wO3elWM6d2$NR/ayKF58q0Bm0BdsR.g.Nt5xYzD0s0t17ZjrYaRpY7nkRekjgHTnqw849pK9FdynmNZAioW6oQBQx3BB5kcd0"
 
   roles:
Index: main/waeup-ansible/hosts
===================================================================
--- main/waeup-ansible/hosts	(revision 15914)
+++ main/waeup-ansible/hosts	(revision 15915)
@@ -1,3 +1,3 @@
-[yet-untouched]
+[yet_untouched]
 
 [vhosts]
Index: main/waeup-ansible/hosts-virtual
===================================================================
--- main/waeup-ansible/hosts-virtual	(revision 15914)
+++ main/waeup-ansible/hosts-virtual	(revision 15915)
@@ -8,5 +8,5 @@
 # vh5.sample.org ansible_host=192.168.36.10 ansible_ssh_private_key_file=.vagrant/machines/vh5/virtualbox/private_key ansible_user=vagrant
 
-[yet-untouched]
+[yet_untouched]
 # servers that are vagrant-wise provisioned, looking like fresh from hetzner
 #
Index: main/waeup-ansible/vhost-bootstrap.yml
===================================================================
--- main/waeup-ansible/vhost-bootstrap.yml	(revision 15914)
+++ main/waeup-ansible/vhost-bootstrap.yml	(revision 15915)
@@ -9,5 +9,5 @@
 # it! Do not run this playbook without having read the README.
 #
-- hosts: yet-untouched
+- hosts: yet_untouched
   become: yes
   vars: