Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 15920)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 15921)
@@ -746,5 +746,5 @@
             value, name, context=context)
 
-class StudentStudyLevelsOverviewExporter(StudentExporter):
+class StudyLevelsOverviewExporter(StudentExporter):
     """The Student Study Levels Overview Exporter first filters the set of
     students by searching the students catalog. Then it exports some student
@@ -824,6 +824,6 @@
             value, name, context=context)
 
-class StudentTranscriptDataExporter(StudentExporter):
-    """The Student Transcript Data Exporter first filters the set of
+class TranscriptDataExporter(StudentExporter):
+    """The Transcript Data Exporter first filters the set of
     students by searching the students catalog. Then it exports student data
     along with their transcript data.
@@ -852,4 +852,4 @@
                     )
         return super(
-            StudentTranscriptDataExporter, self).mangle_value(
-            value, name, context=context)
+            TranscriptDataExporter, self).mangle_value(
+            value, name, context=context)
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 15920)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 15921)
@@ -32,10 +32,10 @@
     StudentExporter, StudentStudyCourseExporter, StudentStudyLevelExporter,
     CourseTicketExporter, StudentPaymentExporter, BedTicketExporter,
-    SchoolFeePaymentsOverviewExporter, StudentStudyLevelsOverviewExporter,
+    SchoolFeePaymentsOverviewExporter, StudyLevelsOverviewExporter,
     ComboCardDataExporter, DataForBursaryExporter,
     StudentUnpaidPaymentExporter, SessionPaymentsOverviewExporter,
     StudentOutstandingCoursesExporter,
     AccommodationPaymentsExporter,
-    StudentTranscriptDataExporter,
+    TranscriptDataExporter,
     get_students,)
 from waeup.kofa.students.accommodation import BedTicket
@@ -1447,17 +1447,17 @@
         return
 
-class StudentStudyLevelsOverviewExporterTest(StudentImportExportSetup):
+class StudyLevelsOverviewExporterTest(StudentImportExportSetup):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(StudentStudyLevelsOverviewExporterTest, self).setUp()
+        super(StudyLevelsOverviewExporterTest, self).setUp()
         self.setup_for_export()
         return
 
     def test_ifaces(self):
-        obj = StudentStudyLevelsOverviewExporter()
+        obj = StudyLevelsOverviewExporter()
         verifyObject(ICSVStudentExporter, obj)
-        verifyClass(ICSVStudentExporter, StudentStudyLevelsOverviewExporter)
+        verifyClass(ICSVStudentExporter, StudyLevelsOverviewExporter)
         return
 
@@ -1469,5 +1469,5 @@
     def test_export(self):
         self.setup_student(self.student)
-        exporter = StudentStudyLevelsOverviewExporter()
+        exporter = StudyLevelsOverviewExporter()
         exporter.export([self.student], self.outfile)
         result = open(self.outfile, 'rb').read()
@@ -1485,5 +1485,5 @@
     def test_export_all(self):
         self.setup_student(self.student)
-        exporter = StudentStudyLevelsOverviewExporter()
+        exporter = StudyLevelsOverviewExporter()
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()
@@ -1533,10 +1533,10 @@
         return
 
-class StudentTranscriptDataExporterTest(StudentImportExportSetup):
+class TranscriptDataExporterTest(StudentImportExportSetup):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(StudentTranscriptDataExporterTest, self).setUp()
+        super(TranscriptDataExporterTest, self).setUp()
         self.setup_for_export()
         return
@@ -1544,5 +1544,5 @@
     def test_export_all(self):
         self.setup_student(self.student)
-        exporter = StudentTranscriptDataExporter()
+        exporter = TranscriptDataExporter()
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()