Index: main/waeup.kofa/trunk/docs/source/userdocs/datacenter/export.rst
===================================================================
--- main/waeup.kofa/trunk/docs/source/userdocs/datacenter/export.rst	(revision 15923)
+++ main/waeup.kofa/trunk/docs/source/userdocs/datacenter/export.rst	(revision 15924)
@@ -221,13 +221,4 @@
   .. automethod:: waeup.kofa.students.export.CourseTicketExporter.mangle_value()
 
-Student Outstanding Courses Exporter
-------------------------------------
-
-.. autoclass:: waeup.kofa.students.export.StudentOutstandingCoursesExporter()
-
-  .. autoattribute:: waeup.kofa.students.export.StudentOutstandingCoursesExporter.fields
-  .. autoattribute:: waeup.kofa.students.export.StudentOutstandingCoursesExporter.title
-  .. automethod:: waeup.kofa.students.export.StudentOutstandingCoursesExporter.mangle_value()
-
 Student Payment Exporter
 ------------------------
@@ -238,11 +229,4 @@
   .. autoattribute:: waeup.kofa.students.export.StudentPaymentExporter.title
   .. automethod:: waeup.kofa.students.export.StudentPaymentExporter.mangle_value()
-
-Student Unpaid Payment Exporter
--------------------------------
-
-.. autoclass:: waeup.kofa.students.export.StudentUnpaidPaymentExporter()
-
-  .. autoattribute:: waeup.kofa.students.export.StudentUnpaidPaymentExporter.title
 
 Bed Ticket Exporter
@@ -265,4 +249,13 @@
   postprocessing by the university.
 
+Outstanding Courses Exporter
+----------------------------
+
+.. autoclass:: waeup.kofa.students.export.OutstandingCoursesExporter()
+
+  .. autoattribute:: waeup.kofa.students.export.OutstandingCoursesExporter.fields
+  .. autoattribute:: waeup.kofa.students.export.OutstandingCoursesExporter.title
+  .. automethod:: waeup.kofa.students.export.OutstandingCoursesExporter.mangle_value()
+
 Data For Bursary Exporter
 -------------------------
@@ -273,4 +266,11 @@
   .. autoattribute:: waeup.kofa.students.export.DataForBursaryExporter.title
   .. automethod:: waeup.kofa.students.export.DataForBursaryExporter.mangle_value()
+
+Unpaid Payments Exporter
+------------------------
+
+.. autoclass:: waeup.kofa.students.export.UnpaidPaymentsExporter()
+
+  .. autoattribute:: waeup.kofa.students.export.UnpaidPaymentsExporter.title
 
 Accommodation Payments Exporter
@@ -302,12 +302,12 @@
   .. automethod:: waeup.kofa.students.export.SessionPaymentsOverviewExporter.mangle_value()
 
-Student Study Levels Overview Exporter
---------------------------------------
-
-.. autoclass:: waeup.kofa.students.export.StudentStudyLevelsOverviewExporter()
-
-  .. autoattribute:: waeup.kofa.students.export.StudentStudyLevelsOverviewExporter.fields
-  .. autoattribute:: waeup.kofa.students.export.StudentStudyLevelsOverviewExporter.title
-  .. automethod:: waeup.kofa.students.export.StudentStudyLevelsOverviewExporter.mangle_value()
+Study Levels Overview Exporter
+------------------------------
+
+.. autoclass:: waeup.kofa.students.export.StudyLevelsOverviewExporter()
+
+  .. autoattribute:: waeup.kofa.students.export.StudyLevelsOverviewExporter.fields
+  .. autoattribute:: waeup.kofa.students.export.StudyLevelsOverviewExporter.title
+  .. automethod:: waeup.kofa.students.export.StudyLevelsOverviewExporter.mangle_value()
 
 Combo Card Data Exporter
@@ -328,4 +328,13 @@
   .. autoattribute:: waeup.kofa.students.export.DataForLecturerExporter.title
   .. automethod:: waeup.kofa.students.export.DataForLecturerExporter.mangle_value()
+
+Transcript Data Exporter
+------------------------
+
+.. autoclass:: waeup.kofa.students.export.TranscriptDataExporter()
+
+  .. autoattribute:: waeup.kofa.students.export.TranscriptDataExporter.fields
+  .. autoattribute:: waeup.kofa.students.export.TranscriptDataExporter.title
+  .. automethod:: waeup.kofa.students.export.TranscriptDataExporter.mangle_value()
 
 File Export
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 15923)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/export.py	(revision 15924)
@@ -164,5 +164,5 @@
 
 def get_payments(students, p_states=None, **kw):
-    """Get all payments of `students` within given payment_date period.
+    """Get all payment tickets of `students` within given payment_date period.
     """
     date_format = '%d/%m/%Y'
@@ -196,5 +196,5 @@
 
 def get_bedtickets(students):
-    """Get all bedtickets of `students`.
+    """Get all bed tickets of `students`.
     """
     tickets = []
@@ -436,4 +436,36 @@
             value, name, context=context)
 
+class StudentPaymentExporter(grok.GlobalUtility, StudentExporterBase):
+    """The Student Payment Exporter first filters the set of students
+    by searching the students catalog. Then it exports student payment
+    tickets by iterating over the items of the student's ``payments``
+    container. If the payment period is given, only tickets, which were
+    paid in payment period, are considered for export.
+    """
+    grok.name('studentpayments')
+
+    fields = tuple(
+        sorted(iface_names(
+            IStudentOnlinePayment, exclude_attribs=False,
+            omit=['display_item', 'certificate', 'student']))) + (
+            'student_id','state','current_session')
+    title = _(u'Student Payments (Data Backup)')
+
+    def filter_func(self, x, **kw):
+        return get_payments(x, **kw)
+
+    def mangle_value(self, value, name, context=None):
+        """The mangler determines the student's id, registration
+        state and current session.
+        """
+        if context is not None:
+            student = context.student
+            if name in ['student_id','state',
+                        'current_session'] and student is not None:
+                value = getattr(student, name, None)
+        return super(
+            StudentPaymentExporter, self).mangle_value(
+            value, name, context=context)
+
 class DataForLecturerExporter(grok.GlobalUtility, StudentExporterBase):
     """The Data for Lecturer Exporter searches for students in the course
@@ -467,5 +499,5 @@
             value, name, context=context)
 
-class StudentOutstandingCoursesExporter(grok.GlobalUtility, StudentExporterBase):
+class OutstandingCoursesExporter(grok.GlobalUtility, StudentExporterBase):
     """The Student Outstanding Courses Exporter first filters the set of 
     students by searching the students catalog. Then it exports students with 
@@ -497,44 +529,12 @@
                 value = context[3]
         return super(
-            StudentOutstandingCoursesExporter, self).mangle_value(
-            value, name, context=context)
-
-class StudentPaymentExporter(grok.GlobalUtility, StudentExporterBase):
-    """The Student Payment Exporter first filters the set of students
-    by searching the students catalog. Then it exports student payment
-    tickets by iterating over the items of the student's ``payments``
-    container. If the payment period is given, only tickets, which were
-    paid in payment period, are considered for export.
-    """
-    grok.name('studentpayments')
-
-    fields = tuple(
-        sorted(iface_names(
-            IStudentOnlinePayment, exclude_attribs=False,
-            omit=['display_item', 'certificate', 'student']))) + (
-            'student_id','state','current_session')
-    title = _(u'Student Payments (Data Backup)')
-
-    def filter_func(self, x, **kw):
-        return get_payments(x, **kw)
-
-    def mangle_value(self, value, name, context=None):
-        """The mangler determines the student's id, registration
-        state and current session.
-        """
-        if context is not None:
-            student = context.student
-            if name in ['student_id','state',
-                        'current_session'] and student is not None:
-                value = getattr(student, name, None)
-        return super(
-            StudentPaymentExporter, self).mangle_value(
-            value, name, context=context)
-
-class StudentUnpaidPaymentExporter(StudentPaymentExporter):
-    """The Student Unpaid Payment Exporter works just like the
-    Student Payments Exporter but it exports only unpaid tickets.
-    This exporter is designed for finding and finally purging outdated
-    payment ticket.
+            OutstandingCoursesExporter, self).mangle_value(
+            value, name, context=context)
+
+class UnpaidPaymentsExporter(StudentPaymentExporter):
+    """The Unpaid Payments Exporter works just like the
+    Student Payment (singular intended) Exporter  but it exports only 
+    unpaid tickets. This exporter is designed for finding and finally 
+    purging outdated payment tickets.
     """
     grok.name('unpaidpayments')
@@ -838,5 +838,5 @@
 
     def mangle_value(self, value, name, context=None):
-        """The mangler determines the trascript data.
+        """The mangler determines and formats the transcript data.
         """
         if name == 'transcript_data':
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 15923)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 15924)
@@ -34,6 +34,6 @@
     SchoolFeePaymentsOverviewExporter, StudyLevelsOverviewExporter,
     ComboCardDataExporter, DataForBursaryExporter,
-    StudentUnpaidPaymentExporter, SessionPaymentsOverviewExporter,
-    StudentOutstandingCoursesExporter,
+    UnpaidPaymentsExporter, SessionPaymentsOverviewExporter,
+    OutstandingCoursesExporter,
     AccommodationPaymentsExporter,
     TranscriptDataExporter,
@@ -797,10 +797,10 @@
         return
 
-class StudentOutstandingCoursesExporterTest(StudentImportExportSetup):
+class OutstandingCoursesExporterTest(StudentImportExportSetup):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(StudentOutstandingCoursesExporterTest, self).setUp()
+        super(OutstandingCoursesExporterTest, self).setUp()
         self.setup_for_export()
         return
@@ -808,7 +808,7 @@
     def test_ifaces(self):
         # make sure we fullfill interface contracts
-        obj = StudentOutstandingCoursesExporter()
+        obj = OutstandingCoursesExporter()
         verifyObject(ICSVStudentExporter, obj)
-        verifyClass(ICSVStudentExporter, StudentOutstandingCoursesExporter)
+        verifyClass(ICSVStudentExporter, OutstandingCoursesExporter)
         return
 
@@ -831,5 +831,5 @@
         self.setup_student(self.student)
         self.student['studycourse']['100']['C3'].score = 25
-        exporter = StudentOutstandingCoursesExporter()
+        exporter = OutstandingCoursesExporter()
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()
@@ -1042,10 +1042,10 @@
         return
 
-class StudentUnpaidPaymentExporterTest(StudentImportExportSetup):
+class UnpaidPaymentsExporterTest(StudentImportExportSetup):
 
     layer = FunctionalLayer
 
     def setUp(self):
-        super(StudentUnpaidPaymentExporterTest, self).setUp()
+        super(UnpaidPaymentsExporterTest, self).setUp()
         self.setup_for_export()
         return
@@ -1055,5 +1055,5 @@
         # set values we can expect in export file
         self.setup_student(self.student)
-        exporter = StudentUnpaidPaymentExporter()
+        exporter = UnpaidPaymentsExporter()
         exporter.export_all(self.app, self.outfile)
         result = open(self.outfile, 'rb').read()