Index: /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py
===================================================================
--- /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py	(revision 15936)
+++ /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/etranzact/browser.py	(revision 15937)
@@ -205,4 +205,5 @@
             'science','clinical','develop','municipal',
             'alumni','conv','matric','waecneco','jambver','pharmlab','lo_ident',
-            'change_course','make_up','iuits','fine','combi'),
+            'change_course','resit1','resit2','resit3','resit4','resit5',
+            'resit6','resit7','resit8','resit9','iuits','fine','combi'),
          }
Index: /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interfaces.py
===================================================================
--- /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interfaces.py	(revision 15936)
+++ /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/interfaces.py	(revision 15937)
@@ -206,4 +206,10 @@
     fine_fee = schema.Float(
         title = _(u'Fine'),
+        default = 0.0,
+        required = False,
+        )
+
+    resit_fee = schema.Float(
+        title = _(u'Make-Up Examination Course Fee'),
         default = 0.0,
         required = False,
Index: /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py
===================================================================
--- /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py	(revision 15936)
+++ /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/browser.py	(revision 15937)
@@ -29,4 +29,5 @@
     StudentBasePDFFormPage, ExportPDFCourseRegistrationSlip,
     CourseTicketDisplayFormPage, StudentTriggerTransitionFormPage,
+    StartClearancePage,
     msave, emit_lock_message)
 from waeup.kofa.students.interfaces import (
@@ -206,2 +207,5 @@
             sigs_in_footer=self._sigsInFooter(),
             note=self.note)
+
+class CustomStartClearancePage(StartClearancePage):
+    with_ac = False
Index: /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/utils.py
===================================================================
--- /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/utils.py	(revision 15936)
+++ /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/students/utils.py	(revision 15937)
@@ -140,4 +140,8 @@
                 return _('Study course data are incomplete.'), None
             amount = academic_session.clearance_fee
+        elif category.startswith('resit'):
+            amount = academic_session.resit_fee
+            number = int(category.strip('resit'))
+            amount *= number
         #elif category == 'bed_allocation':
         #    p_item = self.getAccommodationDetails(student)['bt']
Index: /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py
===================================================================
--- /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py	(revision 15936)
+++ /main/kofacustom.iuokada/trunk/src/kofacustom/iuokada/utils/utils.py	(revision 15937)
@@ -60,4 +60,13 @@
         'fine': 'Fine',
         'combi': 'Combi Payment',
+        'resit1': '1 Make-Up Examination Course',
+        'resit2': '2 Make-Up Examination Courses',
+        'resit3': '3 Make-Up Examination Courses',
+        'resit4': '4 Make-Up Examination Courses',
+        'resit5': '5 Make-Up Examination Courses',
+        'resit6': '6 Make-Up Examination Course',
+        'resit7': '7 Make-Up Examination Courses',
+        'resit8': '8 Make-Up Examination Courses',
+        'resit9': '9 Make-Up Examination Courses',
         }
 
@@ -91,8 +100,17 @@
         'lo_ident': 'Letter of Identification Fee',
         'change_course': 'Change of Course Fee',
-        'make_up': 'Make-up Fee',
+        #'make_up': 'Make-up Fee',
         'iuits': 'IUITS Fee',
         'fine': 'Fine',
         'combi': 'Combi Payment',
+        'resit1': '1 Make-Up Examination Course',
+        'resit2': '2 Make-Up Examination Courses',
+        'resit3': '3 Make-Up Examination Courses',
+        'resit4': '4 Make-Up Examination Courses',
+        'resit5': '5 Make-Up Examination Courses',
+        'resit6': '6 Make-Up Examination Course',
+        'resit7': '7 Make-Up Examination Courses',
+        'resit8': '8 Make-Up Examination Courses',
+        'resit9': '9 Make-Up Examination Courses',
         }
 